package org.dyrk.geocoder;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaWebView;
import org.apache.cordova.CordovaInterface;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import java.util.List;

import android.location.Geocoder;
import android.location.Address;

public class CDVGeocoder extends CordovaPlugin {
    
    Geocoder geocoder;

    @Override
	public void initialize(CordovaInterface cordova, CordovaWebView webView) {
        super.initialize(cordova, webView);
                System.out.print("CDVGeocoder initialize");
	}

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        
        if (action.equals("Address2Coordinates")) {
            String addressString = args.getString(0);
            this.address2coordinates(addressString, callbackContext);
            return true;
        }
	else  if (action.equals("Coordinates2Address")) {
            double longitude = Double.parseDouble(args.getString(0));
	    double latitude  = Double.parseDouble(args.getString(1));
            this.coordinates2address(longitude, latitude, callbackContext);
            return true;
        }
        else {
		callbackContext.error("bad function : " + action);
	}

        return false;
        
    }


	//Dyrk.org - Convert coordinate to adress, obtain street / avenue /city ...
	private void coordinates2address(double longitude, double latitude, CallbackContext callbackContext) {
     		geocoder = new Geocoder(cordova.getActivity().getApplicationContext());
    
	            try {
        	        List<Address> geoResults = geocoder.getFromLocation(latitude, longitude, 1);
                	if (geoResults.size()>0) {
	                    Address addr = geoResults.get(0);
        	            System.out.print(addr);
	                    JSONObject coords = new JSONObject();
        	            coords.put("street", addr.getAddressLine(0));
                	    coords.put("city",   addr.getLocality());
	                    System.out.print(coords);
        	            callbackContext.success(coords);
                	}

	            } catch (Exception e) {
        	        System.out.print(e.getMessage());
                	callbackContext.error(e.getMessage());
	            }



	}


	//Dyrk.org - Convert an adress (string) to coordinate X / coordinate Y

	private void address2coordinates(String addressString, CallbackContext callbackContext) {
     	geocoder = new Geocoder(cordova.getActivity().getApplicationContext());


        if (addressString != null && addressString.length() > 0) {

            try {
                List<Address> geoResults = geocoder.getFromLocationName(addressString, 1);
                while (geoResults.size()==0) {
                    geoResults = this.geocoder.getFromLocationName(addressString, 1);
                }
                if (geoResults.size()>0) {
                    Address addr = geoResults.get(0);
                    System.out.print(addr);
                    
                    JSONObject coords = new JSONObject();
                    coords.put("latitude", addr.getLatitude());
                    coords.put("longitude", addr.getLongitude());

                    System.out.print(coords);
                    callbackContext.success(coords);
                }
            
            } catch (Exception e) {
                System.out.print(e.getMessage());
                callbackContext.error(e.getMessage());
            }
            
        } else {
            callbackContext.error("Expected one non-empty string argument.");
        }
    }
    
}
